package bookExamples.ch26Graphics.draw2d;

/**
 * Created by Randeep Singh
 * Professor: Dr. Douglas Lyon
 * Due Date: Feb 9, 2005
 * Class: CR 325
 */

import futils.Futil;

import java.awt.*;
import java.awt.geom.AffineTransform;

public class ImageShape extends Shape {
    int x1 = 0;
    int y1 = 0;
    int x2 = 0;
    int y2 = 0;
    private Image image;
    //String s = ("C:\\Sun\\j4p\\src\\bookExamples\\ch26Graphics\\draw2d\\smiley.jpg");
    static String s = Futil.getReadFile("select an image").toString();

    public ImageShape(int x1, int y1, int x2, int y2) {
        super(x1, y1, x2, y2);
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        image = toolkit.getImage(s);
        MediaTracker mediaTracker = new MediaTracker(this);
        mediaTracker.addImage(image, 0);
        setSize(image.getWidth(null), image.getHeight(null));
    }

    public void paint(Graphics g) {

        Graphics2D g2d = (Graphics2D)g;
        int w = Math.abs(x1-x2);
        int h = Math.abs(y1-y2);
        g2d.drawImage(image, x1, y1,w,h, null);
       // AffineTransform affineTransform = getAffineTransform();
      // double sw =  image.getWidth(this)/w;
      // double sh =  image.getHeight(this)/h;
      //  affineTransform.setToScale(sw,sh);
       // g2d.drawImage(image,
       //         affineTransform, null);

    }

    public Shape getInstance(int x1, int y1, int x2, int y2) {
        ImageShape imageShape = new ImageShape(x1, y1,x2,y2);
        imageShape.setAffineTransform(getAffineTransform());
        return imageShape;
    }
}