package bookExamples.ch26Graphics.draw2d;


import java.awt.*;

public class Line2d extends Shape {
    public Shape getInstance(int x1, int y1, int x2, int y2) {
        return new Line2d(x1, y1, x2, y2);
    }

    public Line2d(int x1, int y1, int x2, int y2) {
        super(x1, y1, x2, y2);
    }

    public Line2d(Vec2d v1, Vec2d v2) {
        super((int) v1.v[0], (int) v1.v[1], (int) v2.v[0], (int) v2.v[1]);
    }

    public void paint(Graphics g) {
        //saveState(g);
        Graphics2D g2d = (Graphics2D)g;
        g2d.drawLine(x1, y1, x2, y2);
        //restoreState(g);
    }

    public String toString() {
        return
                "x1,y1,x2,y2=" + x1 + "," + y1 + "," + x2 + "," + y2;
    }
}
