package pawel;

import gui.In;

import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Date;

/**
 * Created by IntelliJ IDEA.
 * User: pkrepszt
 * Date: Nov 14, 2004
 * Time: 7:19:49 PM
 * To change this template use File | Settings | File Templates.
 */
public class MySSLServer extends UnicastRemoteObject implements SSLChanel {
    public String printInfo() {
        Date d = new Date();
        String s = d.toString();
        return new StringBuffer().append("This must work for me now!!!! ").append(s).toString();
    }
    public static MySSLServer getMySSLServer() throws RemoteException {
        try {
            Class.forName("pawel.MySSLServer_Stub");
        } catch (ClassNotFoundException e) {
            In.message("stub not found...MySSLServer_Stub"+e.getMessage());
            System.exit(0);
        }
        return new MySSLServer();
    }

    private  MySSLServer() throws RemoteException {
        super(0, new RMISSLClientSocketFactory(),
                new RMISSLServerSocketFactory());
        
    }

    public static void main(String args[]) {

         System.setProperty("java.security.policy","rmi.java.policy");
         //System.getProperty("user.home");
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        try {
            MySSLServer self = getMySSLServer();
            Naming.rebind("//localhost/SSLChanel", self);
            System.out.println("MySSLServer bound in registry");
        } catch (Exception e) {
            System.out.println("MySSLServer err bounding in registry: " + e.getMessage());
            e.printStackTrace();
        }
    }
}