package pawel;

import pawel.JInfoFrame;
import pawel.KeyStoreFile;
import pawel.KeyUtil;

import javax.net.ssl.*;
import java.io.*;
import java.net.Socket;
import java.rmi.server.RMIClientSocketFactory;
import java.security.KeyStore;

/**
 * Created by IntelliJ IDEA. User: pkrepszt Date: Nov 16, 2004 Time:
 * 7:24:57 PM To change this template use File | Settings | File
 * Templates.
 */
public class RMISSLClientSocketFactory implements RMIClientSocketFactory,
                                                  Serializable {
    private static JInfoFrame jif2 = new JInfoFrame();


    public Socket createSocket(String IpAddress, int port)
            throws IOException {
        String s = System.getProperty("user.home");
        KeyUtil.ctreateKeyStoreFile("clientKeyStore",
                KeyStoreFile.getCKSbytes());
        KeyUtil.ctreateKeyStoreFile("clientTrustStore",
                KeyStoreFile.getCTSbytes());

        jif2.setSize(600, 600);
        jif2.show();

        SSLSocketFactory ssf = null;
        try {
            char[] passphrase = "ewunia27".toCharArray();
            SSLContext ctx = SSLContext.getInstance("TLS");
            KeyStore ks = KeyStore.getInstance("JKS");
            ks.load(new FileInputStream("clientKeyStore"), passphrase);
            KeyStore ts = KeyStore.getInstance("JKS");
            ts.load(new FileInputStream("clientTrustStore"), null);
            KeyManagerFactory kmf = KeyManagerFactory.getInstance(
                    "SunX509");
            kmf.init(ks, passphrase);
            TrustManagerFactory tmf = TrustManagerFactory.getInstance(
                    "SunX509");
            tmf.init(ts);
            ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            //System.out.println("client KS "+ ks.getProvider().toString());b
            // System.out.println("client TMF "+ tmf.getTrustManagers().toString());
            ssf = ctx.getSocketFactory();
            // System.out.println("client Ciphers "+ ssf.getSupportedCipherSuites().toString());
        } catch (Exception e) {
            jif2.println(getStackTrace(e));
        } //jif2.println("client2");

        return (SSLSocket) ssf.createSocket(IpAddress, port);
    }

    public static String getStackTrace(Exception e) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintStream ps = new PrintStream(baos);
        e.printStackTrace(ps);
        try {
            baos.close();
        } catch (IOException e1) {
            e1.printStackTrace();

        }
        return new String(baos.toByteArray());
    }

}







