package pawel;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;

/**
 * Created by IntelliJ IDEA.
 * User: pkrepszt
 * Date: Nov 14, 2004
 * Time: 6:57:21 PM
 * To change this template use File | Settings | File Templates.
 */
public class MySSLClient {
    private static final String serverIPAddress ="192.168.1.160";
    private static JInfoFrame jif = new JInfoFrame();

    public static void main (String[] args){

       System.setProperty("java.security.policy",
               "rmi.java.policy");

        if (System.getSecurityManager()==null){
            System.setSecurityManager(new RMISecurityManager());
        }
        try{
            SSLChanel ch = (SSLChanel)Naming.lookup("//" + serverIPAddress +"/SSLChanel");
            jif.setSize(300,300);
            jif.show();
            jif.println(ch.printInfo());
        }catch (Exception e){
            jif.setSize(500,600);
            jif.show();
            jif.println("Error at MySSLClient");
            jif.println(getStackTrace(e));
        }

    }
    public static String getStackTrace(Exception e){
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintStream ps = new PrintStream(baos);
        e.printStackTrace(ps);
        try {
            baos.close();
        } catch (IOException e1) {
            //e1.printStackTrace();

        }
        return new String(baos.toByteArray());
    }

}
